prvek(X,[X|_]).
prvek(X,[_|T]) :-
    prvek(X,T).

soused(cesko,slovensko).
soused(cesko,rakousko).
soused(cesko,nemecko).
soused(rakousko,svycarsko).
soused(slovensko,madarsko).
soused(cesko,polsko).
soused(slovensko,polsko).
soused(slovensko,ukrajina).
soused(polsko,ukrajina).
soused(madarsko,ukrajina).
soused(nemecko,svycarsko).
soused(svycarsko,italie).
soused(nemecko,nizozemsko).
soused(nizozemsko,belgie).
soused(belgie,francie).

pruchod(X,Y) :-
    soused(X,Y).
pruchod(X,Y) :-
    soused(Y,X).

% ppad, kdy cestuji do te zem:
cesta(X,X,_,[X]) :- !.

%
cesta(X,Y,Projdeno,[X|Hotovo]) :-
    not(prvek(X,Projdeno)),
    pruchod(X,Z),
    cesta(Z,Y,[X|Projdeno],Hotovo).

cesta(X,Y,Z) :-
    cesta(X,Y,[],Z).

